Subject: bug#29198: closed (Re: bug#29198: Cursor fringe arrow indicator not updating.)

From: [email-masked] (GNU bug Tracking System)
Date: Thu, 09 Nov 2017 16:30:02 +0000

Your bug report

#29198: Cursor fringe arrow indicator not updating.

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
29198: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=29198
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#29198: Cursor fringe arrow indicator not updating.
From: Eli Zaretskii <[email-masked]>
To: Keith David Bershatsky <[email-masked]>
Cc: [email-masked]
Date: Thu, 09 Nov 2017 18:29:14 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

> Date:  Wed, 08 Nov 2017 20:26:16 -0800
> From:  Keith David Bershatsky <[email-masked]>
> Cc:  [email-masked]
> 
> This feature was broken on February 23, 2017 with:
> 
> dee8674414fae2323fd9cbf05aa762e72fa575e5
> 
> I manually reversed the optimization that was applied with the above-mentioned patch, and built a new Emacs 26 downloaded today and am able to verify that this corrects the problem.  I.e., manually reversing *a575e5 as applied to xdisp.c makes everything work properly.

Thanks.  Meanwhile I also arrived at the conclusion that this is a
bug, because the same recipe does work on TTY frames.

Of course, reverting the above changes is not the solution, because as
you yourself noticed, it caused redisplay to be significantly
snappier.  The problem with those changes is that they opened the path
for the code to use redisplay optimizations when overlay-arrows are
displayed, which (the optimizations) are incompatible with
overlay-arrow display.  So the correct solution would be to disable
those optimizations when overlay-arrows are displayed in the buffer.
Which I just did.

Thanks.

Subject: Cursor fringe arrow indicator not updating.
From: Keith David Bershatsky <[email-masked]>
To: Emacs Bug Reports <[email-masked]>
Date: Tue, 07 Nov 2017 11:57:49 -0800
List-Id: <debbugs-submit.debbugs.gnu.org>

The following code works fine with no user configuration in Emacs 25.3.  However, it does not work well with the current version of the master branch.  The overlay arrow indicator is not updating as the user moves up or down in the buffer with the keyboard arrow keys.

Step 1:  Open an Emacs built from the current master branch.

Step 2:  Got to the scratch buffer and evaluate the code below.

Step 3:  Maneuver up and down with the arrow keys navigating the code below.  The fringe bitmap indicator should track the vertical cursor position, but it does not work.

(defface +-left-fringe-cursor-face
  '((t (:foreground "firebrick")))
  "Face for `+-left-fringe-cursor-face'."
  :group '+-mode)

(defun set-fringe-cursor ()
"Doc-string"
  (if (not (and (eobp) (bolp)))
     (setq +-left-fringe-overlay-position (copy-marker (line-beginning-position)))
    (setq +-left-fringe-overlay-position  nil)))

(define-fringe-bitmap '+-cursor-left-fringe-bitmap [128 192 96 48 24 48 96 192 128] 9 8 'center)
(set-fringe-bitmap-face '+-cursor-left-fringe-bitmap '+-left-fringe-cursor-face)

;;; `overlay-arrow-bitmap' is a special SYMBOL defined in xdisp.c.
(defvar +-left-fringe-overlay-position nil
  "Doc-string.")
(make-variable-buffer-local '+-left-fringe-overlay-position)
(add-to-list 'overlay-arrow-variable-list '+-left-fringe-overlay-position)
(put '+-left-fringe-overlay-position 'overlay-arrow-bitmap '+-cursor-left-fringe-bitmap)

(add-hook 'post-command-hook 'set-fringe-cursor 'append 'local)